package com.sun.java.swing.plaf.windows;

import javax.swing.SwingUtilities;
import javax.swing.JMenu;
import sun.awt.AWTAccessor;
import sun.awt.SunToolkit;
import java.awt.Toolkit;
import javax.swing.JMenuBar;
import javax.swing.MenuElement;
import javax.swing.JFrame;
import javax.swing.plaf.basic.ComboPopup;
import javax.swing.MenuSelectionManager;
import java.awt.event.KeyEvent;
import java.awt.Window;
import javax.swing.JRootPane;
import java.awt.KeyEventPostProcessor;
import javax.swing.plaf.ComponentUI;
import javax.swing.JComponent;
import javax.swing.plaf.basic.BasicRootPaneUI;

public class WindowsRootPaneUI extends BasicRootPaneUI
{
    private static final WindowsRootPaneUI windowsRootPaneUI;
    static final WindowsRootPaneUI.AltProcessor altProcessor;
    
    public WindowsRootPaneUI() {
    }
    
    public static ComponentUI createUI(JComponent component) {
        return WindowsRootPaneUI.windowsRootPaneUI;
    }
    
    static {
        windowsRootPaneUI = new WindowsRootPaneUI();
        altProcessor = new WindowsRootPaneUI.AltProcessor();
    }
    
    static class AltProcessor implements KeyEventPostProcessor
    {
        static boolean altKeyPressed;
        static boolean menuCanceledOnPress;
        static JRootPane root;
        static Window winAncestor;
        
        void altPressed(KeyEvent keyEvent) {
            MenuSelectionManager defaultManager = MenuSelectionManager.defaultManager();
            MenuElement[] selectedPath = defaultManager.getSelectedPath();
            if (selectedPath.length > 0 && !(selectedPath[0] instanceof ComboPopup)) {
                defaultManager.clearSelectedPath();
                WindowsRootPaneUI.AltProcessor.menuCanceledOnPress = true;
                keyEvent.consume();
            }
            else if (selectedPath.length > 0) {
                WindowsLookAndFeel.setMnemonicHidden(WindowsRootPaneUI.AltProcessor.menuCanceledOnPress = false);
                WindowsGraphicsUtils.repaintMnemonicsInWindow(WindowsRootPaneUI.AltProcessor.winAncestor);
                keyEvent.consume();
            }
            else {
                WindowsLookAndFeel.setMnemonicHidden(WindowsRootPaneUI.AltProcessor.menuCanceledOnPress = false);
                WindowsGraphicsUtils.repaintMnemonicsInWindow(WindowsRootPaneUI.AltProcessor.winAncestor);
                JMenuBar jMenuBar = (WindowsRootPaneUI.AltProcessor.root != null) ? WindowsRootPaneUI.AltProcessor.root.getJMenuBar() : null;
                if (jMenuBar == null && WindowsRootPaneUI.AltProcessor.winAncestor instanceof JFrame) {
                    jMenuBar = ((JFrame)WindowsRootPaneUI.AltProcessor.winAncestor).getJMenuBar();
                }
                if (((jMenuBar != null) ? jMenuBar.getMenu(0) : null) != null) {
                    keyEvent.consume();
                }
            }
        }
        
        void altReleased(KeyEvent keyEvent) {
            if (WindowsRootPaneUI.AltProcessor.menuCanceledOnPress) {
                WindowsLookAndFeel.setMnemonicHidden(true);
                WindowsGraphicsUtils.repaintMnemonicsInWindow(WindowsRootPaneUI.AltProcessor.winAncestor);
                return;
            }
            MenuSelectionManager defaultManager = MenuSelectionManager.defaultManager();
            if (defaultManager.getSelectedPath().length == 0) {
                JMenuBar jMenuBar = (WindowsRootPaneUI.AltProcessor.root != null) ? WindowsRootPaneUI.AltProcessor.root.getJMenuBar() : null;
                if (jMenuBar == null && WindowsRootPaneUI.AltProcessor.winAncestor instanceof JFrame) {
                    jMenuBar = ((JFrame)WindowsRootPaneUI.AltProcessor.winAncestor).getJMenuBar();
                }
                JMenu menu = (jMenuBar != null) ? jMenuBar.getMenu(0) : null;
                boolean n = false;
                Toolkit defaultToolkit = Toolkit.getDefaultToolkit();
                if ((defaultToolkit instanceof SunToolkit)) {
                    n = (SunToolkit.getContainingWindow(AWTAccessor.getKeyEventAccessor().getOriginalSource(keyEvent)) != WindowsRootPaneUI.AltProcessor.winAncestor || keyEvent.getWhen() <= ((SunToolkit)defaultToolkit).getWindowDeactivationTime(WindowsRootPaneUI.AltProcessor.winAncestor));
                }
                if (menu != null && n == 0) {
                    defaultManager.setSelectedPath(new MenuElement[] { jMenuBar, menu });
                }
                else if (!WindowsLookAndFeel.isMnemonicHidden()) {
                    WindowsLookAndFeel.setMnemonicHidden(true);
                    WindowsGraphicsUtils.repaintMnemonicsInWindow(WindowsRootPaneUI.AltProcessor.winAncestor);
                }
            }
            else if ((defaultManager.getSelectedPath()[0] instanceof ComboPopup)) {
                WindowsLookAndFeel.setMnemonicHidden(true);
                WindowsGraphicsUtils.repaintMnemonicsInWindow(WindowsRootPaneUI.AltProcessor.winAncestor);
            }
            return;
        }
        
        @Override
        public boolean postProcessKeyEvent(KeyEvent keyEvent) {
            if (keyEvent.isConsumed() && keyEvent.getKeyCode() != 18) {
                return WindowsRootPaneUI.AltProcessor.altKeyPressed = false;
            }
            if (keyEvent.getKeyCode() == 18) {
                WindowsRootPaneUI.AltProcessor.root = SwingUtilities.getRootPane(keyEvent.getComponent());
                WindowsRootPaneUI.AltProcessor.winAncestor = ((WindowsRootPaneUI.AltProcessor.root == null) ? null : SwingUtilities.getWindowAncestor(WindowsRootPaneUI.AltProcessor.root));
                if (keyEvent.getID() == 401) {
                    if (!WindowsRootPaneUI.AltProcessor.altKeyPressed) {
                        this.altPressed(keyEvent);
                    }
                    return WindowsRootPaneUI.AltProcessor.altKeyPressed = true;
                }
                else {
                    if (keyEvent.getID() == 402) {
                        if (WindowsRootPaneUI.AltProcessor.altKeyPressed) {
                            this.altReleased(keyEvent);
                        }
                        else if (MenuSelectionManager.defaultManager().getSelectedPath().length <= 0) {
                            WindowsLookAndFeel.setMnemonicHidden(true);
                            WindowsGraphicsUtils.repaintMnemonicsInWindow(WindowsRootPaneUI.AltProcessor.winAncestor);
                        }
                        WindowsRootPaneUI.AltProcessor.altKeyPressed = false;
                    }
                    WindowsRootPaneUI.AltProcessor.root = null;
                    WindowsRootPaneUI.AltProcessor.winAncestor = null;
                }
            }
            else {
                WindowsRootPaneUI.AltProcessor.altKeyPressed = false;
            }
            return false;
        }
        
        static {
            WindowsRootPaneUI.AltProcessor.altKeyPressed = false;
            WindowsRootPaneUI.AltProcessor.menuCanceledOnPress = false;
            WindowsRootPaneUI.AltProcessor.root = null;
            WindowsRootPaneUI.AltProcessor.winAncestor = null;
        }
    }
}
